--- old/usr/src/tools/smatch/src/smatch_slist.c	Mon Aug  5 08:38:45 2019
+++ new/usr/src/tools/smatch/src/smatch_slist.c	Mon Aug  5 08:38:45 2019
@@ -96,9 +96,9 @@
 	if (!a)
 		return 1;
 
-	if (a->owner > b->owner)
-		return -1;
 	if (a->owner < b->owner)
+		return -1;
+	if (a->owner > b->owner)
 		return 1;
 
 	ret = strcmp(a->name, b->name);
@@ -119,38 +119,67 @@
 	return 0;
 }
 
-static int cmp_sm_states(const struct sm_state *a, const struct sm_state *b, int preserve)
+int *dynamic_states;
+void allocate_dynamic_states_array(int num_checks)
 {
+	dynamic_states = calloc(num_checks + 1, sizeof(int));
+}
+
+void set_dynamic_states(unsigned short owner)
+{
+	dynamic_states[owner] = true;
+}
+
+bool has_dynamic_states(unsigned short owner)
+{
+	if (owner >= num_checks)
+		return false;
+	return dynamic_states[owner];
+}
+
+static int cmp_possible_sm(const struct sm_state *a, const struct sm_state *b, int preserve)
+{
 	int ret;
 
-	ret = cmp_tracker(a, b);
-	if (ret)
-		return ret;
+	if (a == b)
+		return 0;
 
-	/* todo:  add hook for smatch_extra.c */
-	if (a->state > b->state)
-		return -1;
-	if (a->state < b->state)
-		return 1;
-	/* This is obviously a massive disgusting hack but we need to preserve
-	 * the unmerged states for smatch extra because we use them in
-	 * smatch_db.c.  Meanwhile if we preserve all the other unmerged states
-	 * then it uses a lot of memory and we don't use it.  Hence this hack.
-	 *
-	 * Also sometimes even just preserving every possible SMATCH_EXTRA state
-	 * takes too much resources so we have to cap that.  Capping is probably
-	 * not often a problem in real life.
-	 */
-	if (a->owner == SMATCH_EXTRA && preserve) {
-		if (a == b)
-			return 0;
-		if (a->merged == 1 && b->merged == 0)
+	if (!has_dynamic_states(a->owner)) {
+		if (a->state > b->state)
 			return -1;
-		if (a->merged == 0)
+		if (a->state < b->state)
 			return 1;
+		return 0;
 	}
 
-	return 0;
+	if (a->owner == SMATCH_EXTRA) {
+		/*
+		 * In Smatch extra you can have borrowed implications.
+		 *
+		 * FIXME: review how borrowed implications work and if they
+		 * are the best way.  See also smatch_implied.c.
+		 *
+		 */
+		ret = cmp_tracker(a, b);
+		if (ret)
+			return ret;
+
+		/*
+		 * We want to preserve leaf states.  They're use to split
+		 * returns in smatch_db.c.
+		 *
+		 */
+		if (preserve) {
+			if (a->merged && !b->merged)
+				return -1;
+			if (!a->merged)
+				return 1;
+		}
+	}
+	if (!a->state->name || !b->state->name)
+		return 0;
+
+	return strcmp(a->state->name, b->state->name);
 }
 
 struct sm_state *alloc_sm_state(int owner, const char *name,
@@ -169,7 +198,6 @@
 	sm_state->pool = NULL;
 	sm_state->left = NULL;
 	sm_state->right = NULL;
-	sm_state->nr_children = 1;
 	sm_state->possible = NULL;
 	add_ptr_list(&sm_state->possible, sm_state);
 	return sm_state;
@@ -197,14 +225,16 @@
 {
 	struct sm_state *tmp;
 	int preserve = 1;
+	int cmp;
 
 	if (too_many_possible(to))
 		preserve = 0;
 
 	FOR_EACH_PTR(to->possible, tmp) {
-		if (cmp_sm_states(tmp, new, preserve) < 0)
+		cmp = cmp_possible_sm(tmp, new, preserve);
+		if (cmp < 0)
 			continue;
-		else if (cmp_sm_states(tmp, new, preserve) == 0) {
+		else if (cmp == 0) {
 			return;
 		} else {
 			INSERT_CURRENT(new, tmp);
@@ -214,11 +244,27 @@
 	add_ptr_list(&to->possible, new);
 }
 
-static void copy_possibles(struct sm_state *to, struct sm_state *from)
+static void copy_possibles(struct sm_state *to, struct sm_state *one, struct sm_state *two)
 {
+	struct sm_state *large = one;
+	struct sm_state *small = two;
 	struct sm_state *tmp;
 
-	FOR_EACH_PTR(from->possible, tmp) {
+	/*
+	 * We spend a lot of time copying the possible lists.  I've tried to
+	 * optimize the process a bit.
+	 *
+	 */
+
+	if (ptr_list_size((struct ptr_list *)two->possible) >
+	    ptr_list_size((struct ptr_list *)one->possible)) {
+		large = two;
+		small = one;
+	}
+
+	to->possible = clone_slist(large->possible);
+	add_possible_sm(to, to);
+	FOR_EACH_PTR(small->possible, tmp) {
 		add_possible_sm(to, tmp);
 	} END_FOR_EACH_PTR(tmp);
 }
@@ -234,8 +280,13 @@
 	return tmp;
 }
 
+static struct symbol *oom_func;
+static int oom_limit = 3000000;  /* Start with a 3GB limit */
 int out_of_memory(void)
 {
+	if (oom_func)
+		return 1;
+
 	/*
 	 * I decided to use 50M here based on trial and error.
 	 * It works out OK for the kernel and so it should work
@@ -243,6 +294,25 @@
 	 */
 	if (sm_state_counter * sizeof(struct sm_state) >= 100000000)
 		return 1;
+
+	/*
+	 * We're reading from statm to figure out how much memory we
+	 * are using.  The problem is that at the end of the function
+	 * we release the memory, so that it can be re-used but it
+	 * stays in cache, it's not released to the OS.  So then if
+	 * we allocate memory for different purposes we can easily
+	 * hit the 3GB limit on the next function, so that's why I give
+	 * the next function an extra 100MB to work with.
+	 *
+	 */
+	if (get_mem_kb() > oom_limit) {
+		oom_func = cur_func_sym;
+		final_pass++;
+		sm_perror("OOM: %luKb sm_state_count = %d", get_mem_kb(), sm_state_counter);
+		final_pass--;
+		return 1;
+	}
+
 	return 0;
 }
 
@@ -297,6 +367,10 @@
 
 	free_stack_and_strees(&all_pools);
 	sm_state_counter = 0;
+	if (oom_func) {
+		oom_limit += 100000;
+		oom_func = NULL;
+	}
 }
 
 unsigned long get_pool_count(void)
@@ -316,7 +390,6 @@
 	ret->possible = clone_slist(s->possible);
 	ret->left = s->left;
 	ret->right = s->right;
-	ret->nr_children = s->nr_children;
 	return ret;
 }
 
@@ -394,10 +467,9 @@
 	result->merged = 1;
 	result->left = one;
 	result->right = two;
-	result->nr_children = one->nr_children + two->nr_children;
-	copy_possibles(result, one);
-	copy_possibles(result, two);
 
+	copy_possibles(result, one, two);
+
 	/*
 	 * The ->line information is used by deref_check where we complain about
 	 * checking pointers that have already been dereferenced.  Let's say we
@@ -718,7 +790,7 @@
 	struct stree *implied_two = NULL;
 	AvlIter one_iter;
 	AvlIter two_iter;
-	struct sm_state *tmp_sm;
+	struct sm_state *one, *two, *res;
 
 	if (out_of_memory())
 		return;
@@ -761,28 +833,30 @@
 	for (;;) {
 		if (!one_iter.sm || !two_iter.sm)
 			break;
-		if (cmp_tracker(one_iter.sm, two_iter.sm) < 0) {
-			sm_perror(" in %s", __func__);
-			avl_iter_next(&one_iter);
-		} else if (cmp_tracker(one_iter.sm, two_iter.sm) == 0) {
-			if (add_pool && one_iter.sm != two_iter.sm) {
-				one_iter.sm->pool = implied_one;
-				if (implied_one->base_stree)
-					one_iter.sm->pool = implied_one->base_stree;
-				two_iter.sm->pool = implied_two;
-				if (implied_two->base_stree)
-					two_iter.sm->pool = implied_two->base_stree;
-			}
-			tmp_sm = merge_sm_states(one_iter.sm, two_iter.sm);
-			add_possible_sm(tmp_sm, one_iter.sm);
-			add_possible_sm(tmp_sm, two_iter.sm);
-			avl_insert(&results, tmp_sm);
-			avl_iter_next(&one_iter);
-			avl_iter_next(&two_iter);
-		} else {
-			sm_perror(" in %s", __func__);
-			avl_iter_next(&two_iter);
+
+		one = one_iter.sm;
+		two = two_iter.sm;
+
+		if (one == two) {
+			avl_insert(&results, one);
+			goto next;
 		}
+
+		if (add_pool) {
+			one->pool = implied_one;
+			if (implied_one->base_stree)
+				one->pool = implied_one->base_stree;
+			two->pool = implied_two;
+			if (implied_two->base_stree)
+				two->pool = implied_two->base_stree;
+		}
+		res = merge_sm_states(one, two);
+		add_possible_sm(res, one);
+		add_possible_sm(res, two);
+		avl_insert(&results, res);
+next:
+		avl_iter_next(&one_iter);
+		avl_iter_next(&two_iter);
 	}
 
 	free_stree(to);
--- old/usr/src/tools/smatch/src/smatch_slist.h	Mon Aug  5 08:38:46 2019
+++ new/usr/src/tools/smatch/src/smatch_slist.h	Mon Aug  5 08:38:46 2019
@@ -96,3 +96,4 @@
 
 void all_return_states_hook(void (*callback)(void));
 
+void allocate_dynamic_states_array(int num_checks);
--- old/usr/src/tools/smatch/src/smatch_statement_count.c	Mon Aug  5 08:38:46 2019
+++ new/usr/src/tools/smatch/src/smatch_statement_count.c	Mon Aug  5 08:38:46 2019
@@ -79,6 +79,7 @@
 {
 	my_id = id;
 
+	set_dynamic_states(my_id);
 	add_hook(match_statement, STMT_HOOK);
 	add_merge_hook(my_id, &merge_states);
 
--- old/usr/src/tools/smatch/src/smatch_states.c	Mon Aug  5 08:38:46 2019
+++ new/usr/src/tools/smatch/src/smatch_states.c	Mon Aug  5 08:38:46 2019
@@ -84,7 +84,7 @@
 {
 	struct sm_state *ret;
 
-	if (!name)
+	if (!name || !state)
 		return NULL;
 
 	if (read_only)
@@ -93,7 +93,7 @@
 	if (option_debug || strcmp(check_name(owner), option_debug_check) == 0) {
 		struct smatch_state *s;
 
-		s = get_state(owner, name, sym);
+		s = __get_state(owner, name, sym);
 		if (!s)
 			sm_msg("%s new [%s] '%s' %s", __func__,
 			       check_name(owner), name, show_state(state));
@@ -196,7 +196,7 @@
 	    strcmp(check_name(sm->owner), option_debug_check) == 0) {
 		struct smatch_state *s;
 
-		s = get_state(sm->owner, sm->name, sm->sym);
+		s = __get_state(sm->owner, sm->name, sm->sym);
 		if (!s)
 			sm_msg("%s new %s", __func__, show_sm(sm));
 		else
@@ -222,7 +222,7 @@
 	    strcmp(check_name(sm->owner), option_debug_check) == 0) {
 		struct smatch_state *s;
 
-		s = get_state(sm->owner, sm->name, sm->sym);
+		s = __get_state(sm->owner, sm->name, sm->sym);
 		if (!s)
 			sm_msg("%s new %s", __func__, show_sm(sm));
 		else
@@ -245,7 +245,7 @@
 	    strcmp(check_name(sm->owner), option_debug_check) == 0) {
 		struct smatch_state *s;
 
-		s = get_state(sm->owner, sm->name, sm->sym);
+		s = __get_state(sm->owner, sm->name, sm->sym);
 		if (!s)
 			sm_msg("%s new %s", __func__, show_sm(sm));
 		else
@@ -477,7 +477,7 @@
 	if (option_debug || strcmp(check_name(owner), option_debug_check) == 0) {
 		struct smatch_state *tmp;
 
-		tmp = get_state(owner, name, sym);
+		tmp = __get_state(owner, name, sym);
 		sm_msg("%s [%s] '%s'.  Was %s.  Now T:%s F:%s", __func__,
 		       check_name(owner),  name, show_state(tmp),
 		       show_state(true_state), show_state(false_state));
@@ -531,7 +531,7 @@
 	if (option_debug || strcmp(check_name(owner), option_debug_check) == 0) {
 		struct smatch_state *tmp;
 
-		tmp = get_state(owner, name, sym);
+		tmp = __get_state(owner, name, sym);
 		sm_msg("%s [%s] '%s'.  Was %s.  Now T:%s F:%s", __func__,
 		       check_name(owner),  name, show_state(tmp),
 		       show_state(true_sm ? true_sm->state : NULL),
@@ -789,7 +789,6 @@
 {
 	struct stree *old_false, *old_true;
 
-	__use_cond_stack(&cond_false_stack);
 	old_false = pop_stree(&cond_false_stack);
 	old_true = pop_stree(&cond_true_stack);
 	push_stree(&cond_false_stack, old_true);
--- old/usr/src/tools/smatch/src/smatch_stored_conditions.c	Mon Aug  5 08:38:47 2019
+++ new/usr/src/tools/smatch/src/smatch_stored_conditions.c	Mon Aug  5 08:38:47 2019
@@ -238,11 +238,14 @@
 void register_stored_conditions(int id)
 {
 	my_id = id;
+	set_dynamic_states(my_id);
 }
 
 void register_stored_conditions_links(int id)
 {
 	link_id = id;
+	db_ignore_states(link_id);
+	set_dynamic_states(link_id);
 	add_merge_hook(link_id, &merge_links);
 	add_modification_hook(link_id, &match_link_modify);
 }
--- old/usr/src/tools/smatch/src/smatch_string_list.c	Mon Aug  5 08:38:47 2019
+++ new/usr/src/tools/smatch/src/smatch_string_list.c	Mon Aug  5 08:38:47 2019
@@ -20,14 +20,16 @@
 int list_has_string(struct string_list *str_list, const char *str)
 {
 	char *tmp;
+	int cmp;
 
 	if (!str)
 		return 0;
 
 	FOR_EACH_PTR(str_list, tmp) {
-		if (strcmp(tmp, str) < 0)
+		cmp = strcmp(tmp, str);
+		if (cmp < 0)
 			continue;
-		if (strcmp(tmp, str) == 0)
+		if (cmp == 0)
 			return 1;
 		return 0;
 	} END_FOR_EACH_PTR(tmp);
@@ -34,23 +36,26 @@
 	return 0;
 }
 
-void insert_string(struct string_list **str_list, const char *_new)
+int insert_string(struct string_list **str_list, const char *_new)
 {
 	char *new = (char *)_new;
 	char *tmp;
+	int cmp;
 
 	FOR_EACH_PTR(*str_list, tmp) {
-		if (strcmp(tmp, new) < 0)
+		cmp = strcmp(tmp, new);
+		if (cmp < 0)
 			continue;
-		else if (strcmp(tmp, new) == 0) {
-			return;
+		else if (cmp == 0) {
+			return 0;
 		} else {
 			INSERT_CURRENT(alloc_string(new), tmp);
-			return;
+			return 1;
 		}
 	} END_FOR_EACH_PTR(tmp);
 	new = alloc_string(new);
 	add_ptr_list(str_list, new);
+	return 1;
 }
 
 struct string_list *clone_str_list(struct string_list *orig)
--- old/usr/src/tools/smatch/src/smatch_strlen.c	Mon Aug  5 08:38:47 2019
+++ new/usr/src/tools/smatch/src/smatch_strlen.c	Mon Aug  5 08:38:47 2019
@@ -333,6 +333,8 @@
 {
 	my_strlen_id = id;
 
+	set_dynamic_states(my_strlen_id);
+
 	add_unmatched_state_hook(my_strlen_id, &unmatched_strlen_state);
 
 	select_caller_info_hook(set_param_strlen, STR_LEN);
@@ -354,6 +356,7 @@
 void register_strlen_equiv(int id)
 {
 	my_equiv_id = id;
+	set_dynamic_states(my_equiv_id);
 	add_function_assign_hook("strlen", &match_strlen, NULL);
 	add_modification_hook(my_equiv_id, &set_strlen_equiv_undefined);
 }
--- old/usr/src/tools/smatch/src/smatch_struct_assignment.c	Mon Aug  5 08:38:48 2019
+++ new/usr/src/tools/smatch/src/smatch_struct_assignment.c	Mon Aug  5 08:38:48 2019
@@ -445,6 +445,23 @@
 	__struct_members_copy(COPY_MEMCPY, expr, remove_addr(dest), remove_addr(src));
 }
 
+static void match_memdup(const char *fn, struct expression *call_expr,
+			struct expression *expr, void *_unused)
+{
+	struct expression *left, *right, *arg;
+
+	if (!expr || expr->type != EXPR_ASSIGNMENT)
+		return;
+
+	left = strip_expr(expr->left);
+	right = strip_expr(expr->right);
+
+	if (right->type != EXPR_CALL)
+		return;
+	arg = get_argument_from_call_expr(right->args, 0);
+	__struct_members_copy(COPY_MEMCPY, expr, left, arg);
+}
+
 static void match_memcpy_unknown(const char *fn, struct expression *expr, void *_arg)
 {
 	struct expression *dest;
@@ -548,6 +565,9 @@
 	add_function_hook("__memcpy", &match_memcpy, INT_PTR(0));
 	add_function_hook("__memmove", &match_memcpy, INT_PTR(0));
 
+	if (option_project == PROJ_KERNEL)
+		return_implies_state_sval("kmemdup", valid_ptr_min_sval, valid_ptr_max_sval, &match_memdup, NULL);
+
 	add_function_hook("sscanf", &match_sscanf, NULL);
 
 	add_hook(&unop_expr, OP_HOOK);
--- old/usr/src/tools/smatch/src/smatch_sval.c	Mon Aug  5 08:38:48 2019
+++ new/usr/src/tools/smatch/src/smatch_sval.c	Mon Aug  5 08:38:48 2019
@@ -67,7 +67,7 @@
 	sval_t ret;
 
 	if (!type)
-		type = &int_ctype;
+		type = &llong_ctype;
 
 	ret.type = type;
 	ret.value = val;
@@ -94,6 +94,8 @@
 
 int sval_unsigned(sval_t sval)
 {
+	if (is_ptr_type(sval.type))
+		return true;
 	return type_unsigned(sval.type);
 }
 
@@ -231,7 +233,7 @@
 {
 	if (sval_is_negative(sval) && type_unsigned(type))
 		return 1;
-	if (type_signed(type) &&  sval_unsigned(sval))
+	if (type_signed(type) && sval_unsigned(sval))
 		return 0;
 	if (type_signed(sval.type) &&
 	    sval.value < sval_type_min(type).value)
@@ -458,6 +460,8 @@
 		}
 	}
 
+	if (op == '-')
+		ret.type = ssize_t_ctype;
 	return ret;
 }
 
@@ -583,15 +587,34 @@
 	return sval_binop_overflows(left, op, right);
 }
 
-unsigned long long fls_mask(unsigned long long uvalue)
+int find_first_zero_bit(unsigned long long uvalue)
 {
-	unsigned long long high_bit = 0;
+	int i;
 
+	for (i = 0; i < 64; i++) {
+		if (!(uvalue & (1ULL << i)))
+			return i;
+	}
+	return i;
+}
+
+int sm_fls64(unsigned long long uvalue)
+{
+	int high_bit = 0;
+
 	while (uvalue) {
 		uvalue >>= 1;
 		high_bit++;
 	}
 
+	return high_bit;
+}
+
+unsigned long long fls_mask(unsigned long long uvalue)
+{
+	int high_bit = 0;
+
+	high_bit = sm_fls64(uvalue);
 	if (high_bit == 0)
 		return 0;
 
@@ -607,6 +630,8 @@
 {
 	char buf[30];
 
+	if (sval_is_ptr(sval) && sval.value == valid_ptr_max)
+		return "ptr_max";
 	if (sval_unsigned(sval) && sval.value == ULLONG_MAX)
 		return "u64max";
 	if (sval_unsigned(sval) && sval.value == UINT_MAX)
@@ -638,6 +663,22 @@
 	return alloc_sname(buf);
 }
 
+const char *sval_to_str_or_err_ptr(sval_t sval)
+{
+	char buf[12];
+
+	if (option_project != PROJ_KERNEL ||
+	    !is_ptr_type(sval.type))
+		return sval_to_str(sval);
+
+	if (sval.uvalue >= -4905ULL) {
+		snprintf(buf, sizeof(buf), "(%lld)", sval.value);
+		return alloc_sname(buf);
+	}
+
+	return sval_to_str(sval);
+}
+
 const char *sval_to_numstr(sval_t sval)
 {
 	char buf[30];
--- old/usr/src/tools/smatch/src/smatch_type.c	Mon Aug  5 08:38:49 2019
+++ new/usr/src/tools/smatch/src/smatch_type.c	Mon Aug  5 08:38:49 2019
@@ -29,6 +29,8 @@
 
 	if (!sym)
 		return NULL;
+	if (sym->type == SYM_BASETYPE)
+		return sym;
 	ret = get_base_type(sym);
 	if (!ret)
 		return NULL;
@@ -75,6 +77,10 @@
 	if (!right)
 		return NULL;
 
+	if (expr->op == '-' &&
+	    (is_ptr_type(left) && is_ptr_type(right)))
+		return ssize_t_ctype;
+
 	if (left->type == SYM_PTR || left->type == SYM_ARRAY)
 		return left;
 	if (right->type == SYM_PTR || right->type == SYM_ARRAY)
@@ -269,6 +275,9 @@
 	case EXPR_LOGICAL:
 		ret = &int_ctype;
 		break;
+	case EXPR_OFFSETOF:
+		ret = &ulong_ctype;
+		break;
 	default:
 		return NULL;
 	}
@@ -283,17 +292,11 @@
 static struct symbol *get_final_type_helper(struct expression *expr)
 {
 	/*
-	 * I'm not totally positive I understand types...
+	 * The problem is that I wrote a bunch of Smatch to think that
+	 * you could do get_type() on an expression and it would give
+	 * you what the comparison was type promoted to.  This is wrong
+	 * but fixing it is a big of work...  Hence this horrible hack.
 	 *
-	 * So, when you're doing pointer math, and you do a subtraction, then
-	 * the sval_binop() and whatever need to know the type of the pointer
-	 * so they can figure out the alignment.  But the result is going to be
-	 * and ssize_t.  So get_operation_type() gives you the pointer type
-	 * and get_type() gives you ssize_t.
-	 *
-	 * Most of the time the operation type and the final type are the same
-	 * but this just handles the few places where they are different.
-	 *
 	 */
 
 	expr = strip_parens(expr);
@@ -300,22 +303,9 @@
 	if (!expr)
 		return NULL;
 
-	switch (expr->type) {
-	case EXPR_COMPARE:
+	if (expr->type == EXPR_COMPARE)
 		return &int_ctype;
-	case EXPR_BINOP: {
-		struct symbol *left, *right;
 
-		if (expr->op != '-')
-			return NULL;
-
-		left = get_type(expr->left);
-		right = get_type(expr->right);
-		if (type_is_ptr(left) || type_is_ptr(right))
-			return ssize_t_ctype;
-		}
-	}
-
 	return NULL;
 }
 
@@ -397,16 +387,7 @@
 
 int is_pointer(struct expression *expr)
 {
-	struct symbol *sym;
-
-	sym = get_type(expr);
-	if (!sym)
-		return 0;
-	if (sym == &string_ctype)
-		return 0;
-	if (sym->type == SYM_PTR)
-		return 1;
-	return 0;
+	return type_is_ptr(get_type(expr));
 }
 
 int returns_pointer(struct symbol *sym)
@@ -442,7 +423,7 @@
 		base_type = &llong_ctype;
 	ret.type = base_type;
 
-	if (type_unsigned(base_type)) {
+	if (type_unsigned(base_type) || is_ptr_type(base_type)) {
 		ret.value = 0;
 		return ret;
 	}
@@ -604,7 +585,7 @@
 
 	if (strncmp(name, ".", 1) == 0)
 		name += 1;
-	if (strncmp(name, "->", 2) == 0)
+	else if (strncmp(name, "->", 2) == 0)
 		name += 2;
 
 	FOR_EACH_PTR(symbol_list, tmp) {
@@ -619,10 +600,12 @@
 		if (strcmp(tmp->ident->name, name) == 0)
 			return tmp;
 
-		chunk_len = strlen(tmp->ident->name);
+		chunk_len = tmp->ident->len;
 		if (strncmp(tmp->ident->name, name, chunk_len) == 0 &&
 		    (name[chunk_len] == '.' || name[chunk_len] == '-')) {
 			sub = get_real_base_type(tmp);
+			if (sub->type == SYM_PTR)
+				sub = get_real_base_type(sub);
 			return get_member_from_string(sub->symbol_list, name + chunk_len);
 		}
 
@@ -741,7 +724,7 @@
 		return snprintf(buf, size, "<unknown>");
 
 	if (type->type == SYM_BASETYPE) {
-		return snprintf(buf, size, base_type_str(type));
+		return snprintf(buf, size, "%s", base_type_str(type));
 	} else if (type->type == SYM_PTR) {
 		type = get_real_base_type(type);
 		n = type_str_helper(buf, size, type);
@@ -795,6 +778,8 @@
 		if (n > size)
 			return n;
 		return n + snprintf(buf + n, size - n, "}");
+	} else if (type->type == SYM_ENUM) {
+		return snprintf(buf, size, "enum %s", type->ident ? type->ident->name : "<unknown>");
 	} else {
 		return snprintf(buf, size, "<type %d>", type->type);
 	}
--- old/usr/src/tools/smatch/src/smatch_type_val.c	Mon Aug  5 08:38:49 2019
+++ new/usr/src/tools/smatch/src/smatch_type_val.c	Mon Aug  5 08:38:49 2019
@@ -396,9 +396,6 @@
 		return;
 
 	type = get_type(expr->left);
-	if (type && type->type == SYM_STRUCT)
-		return;
-
 	member = get_member_name(expr->left);
 	if (!member)
 		return;
--- old/usr/src/tools/smatch/src/smatch_untracked_param.c	Mon Aug  5 08:38:49 2019
+++ new/usr/src/tools/smatch/src/smatch_untracked_param.c	Mon Aug  5 08:38:49 2019
@@ -39,10 +39,12 @@
 static int tracked;
 
 STATE(untracked);
+STATE(lost);
 
 typedef void (untracked_hook)(struct expression *call, int param);
 DECLARE_PTR_LIST(untracked_hook_list, untracked_hook *);
 static struct untracked_hook_list *untracked_hooks;
+static struct untracked_hook_list *lost_hooks;
 
 struct int_stack *tracked_stack;
 
@@ -62,13 +64,46 @@
 	} END_FOR_EACH_PTR(fn);
 }
 
+void add_lost_param_hook(void (func)(struct expression *call, int param))
+{
+	untracked_hook **p = malloc(sizeof(untracked_hook *));
+	*p = func;
+	add_ptr_list(&lost_hooks, p);
+}
+
+static void call_lost_callbacks(struct expression *expr, int param)
+{
+	untracked_hook **fn;
+
+	FOR_EACH_PTR(lost_hooks, fn) {
+		(*fn)(expr, param);
+	} END_FOR_EACH_PTR(fn);
+}
+
 static void assume_tracked(struct expression *call_expr, int param, char *key, char *value)
 {
 	tracked = 1;
 }
 
-void mark_untracked(struct expression *expr, int param, const char *key, const char *value)
+static char *get_array_from_key(struct expression *expr, int param, const char *key, struct symbol **sym)
 {
+	struct expression *arg;
+
+	arg = get_argument_from_call_expr(expr->args, param);
+	if (!arg)
+		return NULL;
+	if (arg->type != EXPR_PREOP || arg->op != '&')
+		return NULL;
+	arg = arg->unop;
+	if (!is_array(arg))
+		return NULL;
+	arg = get_array_base(arg);
+
+	return expr_to_var_sym(arg, sym);
+}
+
+static void mark_untracked_lost(struct expression *expr, int param, const char *key, int type)
+{
 	char *name;
 	struct symbol *sym;
 
@@ -78,15 +113,31 @@
 		return;
 
 	name = return_state_to_var_sym(expr, param, key, &sym);
-	if (!name || !sym)
-		goto free;
+	if (!name || !sym) {
+		name = get_array_from_key(expr, param, key, &sym);
+		if (!name || !sym)
+			goto free;
+	}
 
+	if (type == LOST_PARAM)
+		call_lost_callbacks(expr, param);
 	call_untracked_callbacks(expr, param);
 	set_state(my_id, name, sym, &untracked);
 free:
 	free_string(name);
+
 }
 
+void mark_untracked(struct expression *expr, int param, const char *key, const char *value)
+{
+	mark_untracked_lost(expr, param, key, UNTRACKED_PARAM);
+}
+
+void mark_lost(struct expression *expr, int param, const char *key, const char *value)
+{
+	mark_untracked_lost(expr, param, key, LOST_PARAM);
+}
+
 static int lost_in_va_args(struct expression *expr)
 {
 	struct symbol *fn;
@@ -133,7 +184,8 @@
 	} END_FOR_EACH_PTR(arg);
 }
 
-void mark_all_params_untracked(int return_id, char *return_ranges, struct expression *expr)
+
+static void mark_all_params(int return_id, char *return_ranges, int type)
 {
 	struct symbol *arg;
 	int param;
@@ -145,14 +197,27 @@
 		if (!arg->ident)
 			continue;
 		sql_insert_return_states(return_id, return_ranges,
-					 UNTRACKED_PARAM, param, "$", "");
+					 type, param, "$", "");
 	} END_FOR_EACH_PTR(arg);
 }
 
+
+void mark_all_params_untracked(int return_id, char *return_ranges, struct expression *expr)
+{
+	mark_all_params(return_id, return_ranges, UNTRACKED_PARAM);
+}
+
+void mark_all_params_lost(int return_id, char *return_ranges, struct expression *expr)
+{
+	mark_all_params(return_id, return_ranges, LOST_PARAM);
+}
+
 static void print_untracked_params(int return_id, char *return_ranges, struct expression *expr)
 {
+	struct sm_state *sm;
 	struct symbol *arg;
 	int param;
+	int type;
 
 	param = -1;
 	FOR_EACH_PTR(cur_func_sym->ctype.base_type->arguments, arg) {
@@ -160,12 +225,21 @@
 
 		if (!arg->ident)
 			continue;
-		if (!get_state(my_id, arg->ident->name, arg) &&
-		    !__bail_on_rest_of_function)  /* hairy functions are untrackable */
+
+		if (__bail_on_rest_of_function) {
+			/* hairy functions are lost */
+			type = LOST_PARAM;
+		} else if ((sm = get_sm_state(my_id, arg->ident->name, arg))) {
+			if (slist_has_state(sm->possible, &lost))
+				type = LOST_PARAM;
+			else
+				type = UNTRACKED_PARAM;
+		} else {
 			continue;
+		}
 
 		sql_insert_return_states(return_id, return_ranges,
-					 UNTRACKED_PARAM, param, "$", "");
+					 type, param, "$", "");
 	} END_FOR_EACH_PTR(arg);
 }
 
@@ -237,6 +311,7 @@
 
 	select_return_states_hook(INTERNAL, &assume_tracked);
 	select_return_states_hook(UNTRACKED_PARAM, &mark_untracked);
+	select_return_states_hook(LOST_PARAM, &mark_lost);
 	add_hook(&match_after_call, FUNCTION_CALL_HOOK_AFTER_DB);
 
 	add_split_return_callback(&print_untracked_params);
--- old/usr/src/tools/smatch/src/validation/sm_bitwise1.c	Mon Aug  5 08:38:50 2019
+++ new/usr/src/tools/smatch/src/validation/sm_bitwise1.c	Mon Aug  5 08:38:50 2019
@@ -17,6 +17,6 @@
 sm_bitwise1.c:6 test() implied: x & 1 = '0-1'
 sm_bitwise1.c:7 test() implied: x & 2 = '0,2'
 sm_bitwise1.c:8 test() implied: x & ~(255) = '0,256-4294967040'
-sm_bitwise1.c:9 test() implied: x & ~(255) = '0-4294967040'
+sm_bitwise1.c:9 test() implied: x & ~(255) = '0,256-4294967040'
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_equiv1.c	Mon Aug  5 08:38:50 2019
+++ new/usr/src/tools/smatch/src/validation/sm_equiv1.c	Mon Aug  5 08:38:50 2019
@@ -30,11 +30,11 @@
  * check-output-start
 sm_equiv1.c:13 func() one = 1
 sm_equiv1.c:14 func() two = 1
-sm_equiv1.c:16 func() one = s64min-s64max
-sm_equiv1.c:17 func() two = s64min-s64max
+sm_equiv1.c:16 func() one = 0-u64max
+sm_equiv1.c:17 func() two = 0-u64max
 sm_equiv1.c:19 func() one = 2
 sm_equiv1.c:20 func() two = 2
-sm_equiv1.c:22 func() one = s64min-s64max
-sm_equiv1.c:23 func() two = s64min-s64max
+sm_equiv1.c:22 func() one = 0-u64max
+sm_equiv1.c:23 func() two = 0-u64max
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_implied.c	Mon Aug  5 08:38:50 2019
+++ new/usr/src/tools/smatch/src/validation/sm_implied.c	Mon Aug  5 08:38:50 2019
@@ -26,5 +26,6 @@
  *
  * check-output-start
 sm_implied.c:20 func() error: potentially dereferencing uninitialized 'aa'.
+sm_implied.c:20 func() error: potentially dereferencing uninitialized 'aa'.
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_implied10.c	Mon Aug  5 08:38:51 2019
+++ new/usr/src/tools/smatch/src/validation/sm_implied10.c	Mon Aug  5 08:38:51 2019
@@ -11,7 +11,7 @@
 	else
 		__smatch_value("y");
 
-	if (({int test2 = !!(offset >= 10 || x[offset] == 1); frob(); frob(); frob(); test2;}))
+	if (({int test2 = !!(offset >= 10u || x[offset] == 1); frob(); frob(); frob(); test2;}))
 		__smatch_value("offset");
 	else
 		__smatch_value("offset");
@@ -22,9 +22,9 @@
  * check-command: smatch -I.. -m64 sm_implied10.c
  *
  * check-output-start
-sm_implied10.c:10 func() y = 0,4096-2117777777777777777
-sm_implied10.c:12 func() y = 4096-2117777777777777777
-sm_implied10.c:15 func() offset = 0-s32max
+sm_implied10.c:10 func() y = 0,4096-ptr_max
+sm_implied10.c:12 func() y = 4096-ptr_max
+sm_implied10.c:15 func() offset = s32min-s32max
 sm_implied10.c:17 func() offset = 0-9
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_implied11.c	Mon Aug  5 08:38:51 2019
+++ new/usr/src/tools/smatch/src/validation/sm_implied11.c	Mon Aug  5 08:38:51 2019
@@ -29,6 +29,6 @@
  * check-command: smatch -I.. -m64 sm_implied11.c
  *
  * check-output-start
-sm_implied11.c:25 ad_agg_selection_logic() implied: foo = '0,4096-2117777777777777777'
+sm_implied11.c:25 ad_agg_selection_logic() implied: foo = '0,4096-ptr_max'
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_implied12.c	Mon Aug  5 08:38:51 2019
+++ new/usr/src/tools/smatch/src/validation/sm_implied12.c	Mon Aug  5 08:38:51 2019
@@ -33,6 +33,6 @@
  * check-command: smatch -I.. -m64 sm_implied12.c
  *
  * check-output-start
-sm_implied12.c:28 ad_agg_selection_logic() implied: foo = '0,4096-2117777777777777777'
+sm_implied12.c:28 ad_agg_selection_logic() implied: foo = '0,4096-ptr_max'
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_implied2.c	Mon Aug  5 08:38:52 2019
+++ new/usr/src/tools/smatch/src/validation/sm_implied2.c	Mon Aug  5 08:38:52 2019
@@ -37,5 +37,6 @@
  *
  * check-output-start
 sm_implied2.c:28 func() error: potentially dereferencing uninitialized 'aa'.
+sm_implied2.c:28 func() error: potentially dereferencing uninitialized 'aa'.
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_implied5.c	Mon Aug  5 08:38:52 2019
+++ new/usr/src/tools/smatch/src/validation/sm_implied5.c	Mon Aug  5 08:38:52 2019
@@ -23,5 +23,6 @@
  *
  * check-output-start
 sm_implied5.c:18 func() error: potentially dereferencing uninitialized 'aa'.
+sm_implied5.c:18 func() error: potentially dereferencing uninitialized 'aa'.
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_memory.c	Mon Aug  5 08:38:53 2019
+++ new/usr/src/tools/smatch/src/validation/sm_memory.c	Mon Aug  5 08:38:53 2019
@@ -30,6 +30,5 @@
  *
  * check-output-start
 sm_memory.c:22 func() warn: possible memory leak of 'ac'
-sm_memory.c:22 func() error: memory leak of 'ac'
  * check-output-end
  */
--- old/usr/src/tools/smatch/src/validation/sm_null_deref.c	Mon Aug  5 08:38:53 2019
+++ new/usr/src/tools/smatch/src/validation/sm_null_deref.c	Mon Aug  5 08:38:53 2019
@@ -44,6 +44,7 @@
  *
  * check-output-start
 sm_null_deref.c:18 func() error: potentially dereferencing uninitialized 'aa'.
+sm_null_deref.c:18 func() error: potentially dereferencing uninitialized 'aa'.
 sm_null_deref.c:23 func() error: we previously assumed 'a' could be null (see line 20)
 sm_null_deref.c:25 func() warn: variable dereferenced before check 'a' (see line 23)
 sm_null_deref.c:30 func() error: we previously assumed 'b' could be null (see line 25)
--- old/usr/src/tools/smatch/src/validation/sm_select5.c	Mon Aug  5 08:38:54 2019
+++ new/usr/src/tools/smatch/src/validation/sm_select5.c	Mon Aug  5 08:38:54 2019
@@ -25,7 +25,7 @@
  *
  * check-output-start
 sm_select5.c:15 test() implied: ret = '(-12)'
-sm_select5.c:16 test() implied: a = 's32min-s32max'
+sm_select5.c:16 test() implied: a = 's32min-(-1),4-s32max'
 sm_select5.c:18 test() implied: a = '0-3'
  * check-output-end
  */
--- old/usr/src/uts/i86pc/unix/Makefile	Mon Aug  5 08:38:54 2019
+++ new/usr/src/uts/i86pc/unix/Makefile	Mon Aug  5 08:38:54 2019
@@ -21,7 +21,7 @@
 # Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# Copyright (c) 2018, Joyent, Inc.
+# Copyright 2019 Joyent, Inc.
 # Copyright 2019 OmniOS Community Edition (OmniOSce) Association.
 
 #
@@ -149,6 +149,9 @@
 $(OBJS_DIR)/zutil.o := SMOFF += indenting
 $(OBJS_DIR)/bootrd_cpio.o := SMOFF += allocating_enough_data
 
+# too hairy
+$(OBJS_DIR)/inflate.o := SMATCH=off
+
 #
 #	Default build targets.
 #
